/*
	lpset.c
	Questo programma apre la porta che viene messa come argomento
	permettendo cosi il settaggio con stty e l'uso da parte di lp
	uso:
	lpset porta velocita'
*/
#include <stdio.h>
#include <termio.h>
#define TRUE	1
#define FALSE	0
extern int errno;

int main(int argc, char *argv[])
{
	FILE *fo;
	int speed;
	struct termio stty;

	struct speedtable {
			int speed;
			int parm;
		} speeds[] = {
		{300, B300},
		{600, B600},
		{1200, B1200},
		{2400, B2400},
		{4800, B4800},
		{9600, B9600},
		{19200, EXTA},
		{38400, EXTB},
		{0, }
	};
	struct speedtable *speeds_ptr;

/* verifica dell'argomento velocita' */

	speed = atoi(argv[2]);
	for(speeds_ptr = speeds; speeds_ptr->speed; speeds_ptr++)
	{
		if(speeds_ptr->speed == speed)
		{
			speed = speeds_ptr->parm;
			break;
		}
	}
	if (speeds_ptr-> speed == 0)
	{
		printf("%s: (%s) velocita' non valida", argv[0], speed);
		exit(0);
	}

	if (fo=fopen(argv[1],"w"))
	{
		/* settaggio parametri di trasmissione */
		stty.c_cc[0] = 0x7f;
		stty.c_cc[1] = 0x1c;
		stty.c_cc[2] = 0x08;
		stty.c_cc[3] = 0x15;
		stty.c_cc[4] = 0x04;
		stty.c_cc[5] = 0x00;
		stty.c_cc[6] = 0x00;
		stty.c_cc[7] = 0x00;
		stty.c_iflag = IGNBRK | IXON | IXOFF;
		stty.c_oflag = 0000000;
		stty.c_cflag = CS8 | CREAD | speed;
		stty.c_lflag = 0000000;
		stty.c_line = 0;
		if (ioctl(fileno(fo), TCSETA, &stty) == -1)
		{
			printf("%s: errore SET ioctl %d\n",
				argv[0], errno);
			exit(0);
		}
		while(TRUE)
			sleep(3600);
	}
	else
	{
		printf("%s: non posso aprire %s in W\n",
			argv[0], argv[1]);
	}
	return(-1);
}
